// Create By ChangWei on 2018/10/11
// 定义一个全局变量 作为我开发游戏的常用管理
window.GM = {}
GM.hasLoadImg = {};
GM.hasLoadSound = {};
GM.hasLoadCsv = {};
GM.hasEffect = {};
GM.touchScreen = false
cc.macro.ENABLE_WEBGL_ANTIALIAS = true

cc.Node.prototype.to = function(father, zorder, tag) {
    zorder = zorder || 0;
    if (tag != null) {
        father.addChild(this, zorder, tag);
    } else {
        father.addChild(this, zorder);
    }
    return this;
};
// 快捷设置位置
cc.Node.prototype.p = function(xOrCcp, py) {
    var x = xOrCcp;
    if (y == null) {
        y = xOrCcp.y;
        x = xOrCcp.x;
    };
    this.setPosition(x, y);
    return this;
};
//快速设置在父亲结点的百分比位置, 如果没有父亲则使用设计分辨率
cc.Node.prototype.pp = function(pxOrCcp, py) {
    var px = pxOrCcp;
    if (px == null) {
        px = 0.5;
        py = 0.5;
    } else if (py == null) {
        py = pxOrCcp.y;
        px = pxOrCcp.x;
    }
    var winSize = cc.director.getWinSize();
    var pw = winSize.width, ph = winSize.height;
    if (this.getParent() != null) {
        var size = this.getParent().getContentSize();
        pw = size.width;
        ph = size.height;
    }

    this.setPosition(pw*px, ph*py);
    return this;
};
// 取消点击绑定
cc.Node.prototype.unbindTouch = function() {
    this.off(cc.Node.EventType.TOUCH_START);
    this.off(cc.Node.EventType.TOUCH_MOVE);
    this.off(cc.Node.EventType.TOUCH_END);
    this.off(cc.Node.EventType.TOUCH_CANCEL);

    this.off(cc.Node.EventType.MOUSE_ENTER);
    this.off(cc.Node.EventType.MOUSE_LEAVE);
    return this;
};

GM.pAdd = function (v1, v2) {
    return cc.v2(v1.x + v2.x, v1.y + v2.y);
};

GM.pSub = function (v1, v2) {
    return cc.v2(v1.x - v2.x, v1.y - v2.y);
};

cc.Node.prototype.bindTouchLocate = function(pxOrCcp, py) {
    this.on(cc.Node.EventType.TOUCH_START, function(event) {
        this.lBeganPos_ = this.getPosition();
        this.lBeganPoint_ = cc.v2(event.touch._point.x, event.touch._point.y); //  event.touch._point;
    }, this);

    this.on(cc.Node.EventType.TOUCH_MOVE, function(event) {
        this.setPosition(GM.pAdd(this.lBeganPos_, GM.pSub(event.touch._point, this.lBeganPoint_)));
    }, this);

    this.on(cc.Node.EventType.TOUCH_END, function(event) {
        var pw = cc.winSize.width, ph = cc.winSize.height;
        if (this.getParent() != null) {
            var size = this.getParent().getContentSize();
            pw = size.width;
            ph = size.height;
        }
        console.log("Node Location: ", this.x, this.y, "Percentage:", this.x/pw, this.y/ph);
    }, this);

    // this._touchListener.swallowTouches = false;
    return this;
};

// 快速绑定点击函数 touchSilence-是否静默点击 Shield-是否有点击cdTime
cc.Node.prototype.quickBt = function(fn, touchScale, Shield,touchSilence) {
    this.unbindTouch();
    
    this.lastClickTime = 0; // 上次点击时间
    this.clickCdTime = 300  // 毫秒
    this.canTouch = true;
    this.iHasTouchBegan = false;
    this.getComponent(cc.BlockInputEvents) || this.addComponent(cc.BlockInputEvents)

    this.on(cc.Node.EventType.TOUCH_START, function(event) {
        GM.touchScreen = true
        // console.log("TOUCH_START");
        if (this.canTouch == false){
            return;
        }
        // if (GM.hasTouchDown == true) {
        //     return;
        // }

        this.iHasTouchBegan = true;

        this.BeganScale_ = this.scale;
        this.BeganOpacity_ = this.opacity;
        if (!touchScale) {
            this.setScale(this.BeganScale_*0.9);
            this.opacity = this.BeganOpacity_*0.9;
        };
    }, this);

    this.on(cc.Node.EventType.TOUCH_CANCEL, function(event) {
        if (this.canTouch == false) {
            return;
        }
        if (this.iHasTouchBegan == false) {
            return;
        }

        // GM.hasTouchDown = false;
        this.iHasTouchBegan = false;
        
        if (!touchScale) {
            this.setScale(this.BeganScale_);
            this.opacity = this.BeganOpacity_;
        };
    }, this);

    this.on(cc.Node.EventType.TOUCH_END, function(event) {
        if (this.canTouch == false) {
            return;
        }
        if (this.iHasTouchBegan == false) {
            return;
        }

        // GM.hasTouchDown = false;
        this.iHasTouchBegan = false;
        
        if(audioData && !touchSilence){
            audioData.playSoundByID(2)
        }

        if (!touchScale) {
            this.setScale(this.BeganScale_);
            this.opacity = this.BeganOpacity_;
        };
        if (!Shield) {
            var now = (new Date()).getTime();
            if (now - this.lastClickTime < this.clickCdTime) {
                console.log("---屏蔽过快点击---",now,this.lastClickTime,this.clickCdTime);
                return;
            };
            this.lastClickTime = now;
        };
		//点击拖动距离太大判定为拖动
        let touchStart = event.touch.getStartLocation()
        let touchEnd = event.touch.getLocation();
        let deltaX = touchEnd.x - touchStart.x
        let deltaY = touchEnd.y - touchStart.y
        if(Math.abs(deltaX) <50 && Math.abs(deltaY) < 50){
            fn && fn(event);
        }
    }, this);

    this.autoClick = function () {
        fn();
    }

    return this;
};

/**
 * 快速绑定点击函数
 * 不管手指是在哪里离开点击，都会触发
 * @param touchSilence true无声音false有声音
 * @param Shield true无cd，false有cd
 * @param touchScale true无缩放，false有缩放
 * !!!注,这个函数会导致按钮类父节点被同时响应到,尽管此节点不在父节点的坐标范围内..少用
 */
cc.Node.prototype.quickTouch = function(fn, touchScale, Shield,touchSilence) {
    this.unbindTouch();
    
    this.lastClickTime = 0; // 上次点击时间
    this.clickCdTime = 300  // 毫秒
    this.canTouch = true;
    this.iHasTouchBegan = false;
    this.getComponent(cc.BlockInputEvents) || this.addComponent(cc.BlockInputEvents)

    this.on(cc.Node.EventType.TOUCH_START, function(event) {
        GM.touchScreen = true
        if (this.canTouch == false){
            return;
        }

        this.iHasTouchBegan = true;

        this.BeganScale_ = this.scale;
        this.BeganOpacity_ = this.opacity;
        if (!touchScale) {
            this.setScale(this.BeganScale_*0.9);
            this.opacity = this.BeganOpacity_*0.9;
        };

        if(audioData && !touchSilence){
            audioData.playSoundByID(2)
        }
        if (!Shield) {
            var now = (new Date()).getTime();
            if (now - this.lastClickTime < this.clickCdTime) {
                cc.warn("[屏蔽过快点击]",now,this.lastClickTime,this.clickCdTime);
                return;
            };
            this.lastClickTime = now;
        };
    }, this);

    this.on(cc.Node.EventType.TOUCH_CANCEL, function(event) {
        if (this.canTouch == false) {
            return;
        }
        if (this.iHasTouchBegan == false) {
            return;
        }

        this.iHasTouchBegan = false;

        if (!touchScale) {
            this.setScale(this.BeganScale_);
            this.opacity = this.BeganOpacity_;
        };

        fn && fn(event);
    }, this);

    this.on(cc.Node.EventType.TOUCH_END, function(event) {
        if (this.canTouch == false) {
            return;
        }
        if (this.iHasTouchBegan == false) {
            return;
        }

        this.iHasTouchBegan = false;

        if (!touchScale) {
            this.setScale(this.BeganScale_);
            this.opacity = this.BeganOpacity_;
        };
        fn && fn(event);
    }, this);

    return this;
};

cc.Node.prototype.onHold = function(startFun,finishFun,cancelFun){
    this.getComponent(cc.BlockInputEvents) || this.addComponent(cc.BlockInputEvents)
    this.off(cc.Node.EventType.TOUCH_START)
    this.off(cc.Node.EventType.TOUCH_END)
    this.off(cc.Node.EventType.TOUCH_UP)
    this.off(cc.Node.EventType.TOUCH_CANCEL)
    this.off(cc.Node.EventType.TOUCH_MOVE)
    this.on(cc.Node.EventType.TOUCH_START, (event)=> {
        startFun && startFun()
        event.stopPropagation();//阻止事件向下传递(bug不生效?)
    }, this,true);
    
    //
    this.on(cc.Node.EventType.TOUCH_CANCEL, (event)=> {
        cancelFun && cancelFun(event);
        event.stopPropagation();
    }, this,true);

    this.on(cc.Node.EventType.TOUCH_END, (event)=> {
        finishFun && finishFun(event);
        event.stopPropagation();
    }, this,true);

    this.on(cc.Node.EventType.TOUCH_MOVE, (event)=> {
        event.stopPropagation();
    }, this,true);
}

cc.Node.prototype.onTouch = function(fun){
    this.getComponent(cc.BlockInputEvents) || this.addComponent(cc.BlockInputEvents)
    this.off(cc.Node.EventType.TOUCH_START)
    this.on(cc.Node.EventType.TOUCH_START, function(event) {
        fun && fun()
    }, this);
}

cc.Node.prototype.onClick = function(func,target,isNotScale){


    if(this.getComponent(cc.Button)==null){
        let button=this.addComponent(cc.Button);
        button.transition = cc.Button.Transition.SCALE;
    }
    let button=this.getComponent(cc.Button);
    if(isNotScale){
        button.transition = cc.Button.Transition.NONE;
    }
    
    this.getComponent(cc.BlockInputEvents) || this.addComponent(cc.BlockInputEvents)
    const CD_TIME = 300;
    let LAST_CLICK_TIME = 0;
    let closure = function(){
        let now = new Date().getTime();
        if(now - LAST_CLICK_TIME < CD_TIME )
        {
            console.log("---屏蔽过快点击---");
            return;
        }
        
        LAST_CLICK_TIME = now;
        func.call(target);
    };
    this.off("click");
    this.on("click",closure,target);
};

/**
 * 设置节点上label组件的文本
 * @param str
 */
cc.Node.prototype.setLabel=function(str){
    this._lwLabel=this._lwLabel || this.getComponent(cc.Label) || this.getComponent(cc.RichText);
    if((str||str===0)&&this._lwLabel){
        this._lwLabel.string=str;
    }
};

//多次调用有问题
// cc.Node.prototype.delayCall = function(func, delayTime, bRepeat) {
//     var action = cc.sequence(
//         cc.delayTime(delayTime),
//         cc.callFunc(func)
//     );
//     if (bRepeat) {
//         if (typeof bRepeat === "number") {
//             action = action.repeat(bRepeat);
//         } else {
//             action = action.repeatForever();
//         }
//     };
//     this.runAction(action);
// };
/**
 * 参考c#的String.format() ,使用方式 "ac{0}vb{1}b".format("m","n") => acmvbnb
 * @param args
 * @returns {String}
 */
String.prototype.format = function(args) {
    var result = this;
    if (arguments.length > 0) {
        if (arguments.length == 1 && typeof (args) == "object") {
            for (var key in args) {
                if(args[key]!=undefined){
                    var reg = new RegExp("({" + key + "})", "g");
                    result = result.replace(reg, args[key]);
                }
            }
        }
        else {
            for (var i = 0; i < arguments.length; i++) {
                if (arguments[i] != undefined) {
                    var reg= new RegExp("({)" + i + "(})", "g");
                    result = result.replace(reg, arguments[i]);
                }
            }
        }
    }
    return result;
};

/**
 * 去除左右空格
 */
String.prototype.trim = function(){
    return this.replace(/(^\s*)|(\s*$)/g, "");
}
    
String.prototype.ltrim = function(){
    return this.replace(/(^\s*)/g,"");
}
    
String.prototype.rtrim = function(){
    return this.replace(/(\s*$)/g,"");
}

/**
 * 对Date的扩展，将 Date 转化为指定格式的String
 * (new Date()).Format("yyyy-M-d h:m:s.S")      ==> 2006-7-2 8:9:4.18
 * @param fmt
 * @returns {*}
 * @constructor
 */
Date.prototype.Format = function(fmt)
{ //author: meizz
    var o = {
        "M+" : this.getMonth()+1,                 //月份
        "d+" : this.getDate(),                    //日
        "h+" : this.getHours(),                   //小时
        "m+" : this.getMinutes(),                 //分
        "s+" : this.getSeconds(),                 //秒
        "q+" : Math.floor((this.getMonth()+3)/3), //季度
        "S"  : this.getMilliseconds()             //毫秒
    };
    if(/(y+)/.test(fmt))
        fmt=fmt.replace(RegExp.$1, (this.getFullYear()+"").substr(4 - RegExp.$1.length));
    for(var k in o)
        if(new RegExp("("+ k +")").test(fmt))
            fmt = fmt.replace(RegExp.$1, (RegExp.$1.length==1) ? (o[k]) : (("00"+ o[k]).substr((""+ o[k]).length)));
    return fmt;
};

Number.prototype.toBitString = function()
{
    let units = ["k","m","b","t","a","b","k","m","b","t","a","b"];

    let numLen = 0;
    let numStr = this;
    while(numStr>999)
    {
        numStr = numStr/1000;
        numLen ++;
    }
    numStr = numStr.toString();
    let findDot = numStr.indexOf(".")

    let length = 0 
    if(findDot == -1){
        length = numStr.length
    }else if(findDot >= 1 && findDot<= 2){
        length = 4
    }else if(findDot >= 3){
        length = 3
    }
    numStr = numStr.substr(0,length)
   
    //加上后面补充的0和单位
    if (numLen>0)
    {
        let bit = units[numLen-1]
        if(!bit)
        {
            console.error("数字超过最大长度")
            bit = "?"
        }
        // numStr += zeroStr
        numStr += bit;
    }

    return numStr;
}

/**
 * 游戏顶部数字显示
 * 特殊要求：显示指定位数小数
 * @param {Number} decimal 小数点位数 
 * 
 */
Number.prototype.toFixedString = function(decimal)
{
    let units = ["K","M","B","T","q","a","b","c","d","e","f","g","h","i","j","k","l","m","n"];
    let deci = decimal || 0
    let numLen = 0;
    let numStr = this;
    if (numStr < 1000) {
        let iYushu = Number(numStr)%1
        if (iYushu === 0) {
            numStr = Number(numStr).toFixed(0)
        } else {
            numStr = Number(numStr).toFixed(deci)
        }
        return numStr
    }
    if (numStr < 10000) {
        numStr = Number(numStr).toFixed(0)
        return numStr
    }
    while(numStr>=1000)
    {
        numStr = numStr/1000;
        numLen ++;
        if (numLen > 4) {
            break
        }
    }

    numStr = numStr.toString();
    
    if(numLen>0){
        numStr = Number(numStr).toFixed(deci)
    }else{
        numStr = Number(numStr).toFixed(0)
    }
    if (numLen>0)
    {
        let bit = units[numLen-1]
        if(!bit)
        {
            console.error("数字超过最大长度")
            bit = "?"
        }
        numStr += bit;
    }
    return numStr;
}

/**
 * 扣血显示
 * 比如1K显示为10000，1M显示为1000K
 */
Number.prototype.toIntString = function()
{
    let units = ["k","m","b","t","a","b","k","m","b","t","a","b"];
    let numLen = 0;
    let numStr = this;
    while(numStr>1000)
    {
        numStr = numStr/1000;
        numLen ++;
    }
    if(numLen>0){
        numStr = numStr * 1000
        numLen = numLen - 1
    }
    numStr = Math.round(numStr)
    if (numLen>0)
    {
        let bit = units[numLen-1]
        if(!bit)
        {
            console.error("数字超过最大长度")
            bit = "?"
        }
        numStr = numStr.toString();
        numStr += bit;
    }
    return numStr;
}

/**
 * 数字显示
 * @param {Number} num 数字 
 * 
 */
cc.Label.prototype.setNum = function(num)
{
    num = Number(num)
    this.string = num.toIntString();
}


/***********************Node*************************/
//禁用多点触摸

// cc.Node.maxTouchNum = 1;
// cc.Node.touchNum = 0;
// var __dispatchEvent__ = cc.Node.prototype.dispatchEvent;
// cc.Node.prototype.dispatchEvent = function (event) {
//     if(this._canMultiTouch)
//     {
//         return __dispatchEvent__.call(this, event);
//     }
//     switch (event.type) {
//         case cc.Node.EventType.TOUCH_START:
//             if (cc.Node.touchNum < cc.Node.maxTouchNum) {
//                 cc.Node.touchNum++;
//                 this._canTouch = true;
//                 __dispatchEvent__.call(this, event);
//             }
//             break;
//         case cc.Node.EventType.TOUCH_MOVE:
//             if (!this._canTouch && cc.Node.touchNum < cc.Node.maxTouchNum) {
//                 this._canTouch = true;
//                 cc.Node.touchNum++;
//             }

//             if (this._canTouch) {
//                 __dispatchEvent__.call(this, event);
//             }

//             break;
//         case cc.Node.EventType.TOUCH_END:
//             if (this._canTouch) {
//                 this._canTouch = false;
//                 cc.Node.touchNum--;
//                 __dispatchEvent__.call(this, event);
//             }
//             break;
//         case cc.Node.EventType.TOUCH_CANCEL:
//             if (this._canTouch) {
//                 this._canTouch = false;
//                 cc.Node.touchNum--;
//                 __dispatchEvent__.call(this, event);
//             }
//             break;
//         default:
//             __dispatchEvent__.call(this, event);
//     }
// };

// //多点触摸屏蔽时,如果被点的界面被销毁或隐藏会导致界面不能点击的问题
// var onPostActivated = cc.Node.prototype._onPostActivated;
// cc.Node.prototype._onPostActivated = function (active) {
//     if(!active && this._canTouch){
//         this._canTouch = false;
//         cc.Node.touchNum--;
//     }
//     onPostActivated.call(this,active);
//     this.emit("active",active)
// };

var onPreDestroy = cc.Node.prototype._onPreDestroy;
cc.Node.prototype._onPreDestroy = function () {
    // if(this._canTouch){
    //     this._canTouch = false;
    //     cc.Node.touchNum--;
    // }

    this.emit("destory")
    onPreDestroy.call(this);
};
/***********************Node*************************/


//重写getChildByName 避免循环
var CHILD_ADDED = "child-added";
var CHILD_REMOVED = "child-removed";

var getChildByName = cc.Node.prototype.getChildByName;
cc.Node.prototype.getChildByName=function(name){
    if(!this._childByName)
    {    
        this._childByName = {}

        var locChildren = this._children;
        for (var i = 0, len = locChildren.length; i < len; i++) 
        {
            var childName = locChildren[i]._name
            if(childName)
            {
                this._childByName[childName] = locChildren[i]
            }
        }

        this.on(CHILD_ADDED,child=>{
            if(child._name)
            {
                this._childByName[child._name] = child;
            }
        })
    
        this.on(CHILD_REMOVED,child=>{
            if(child._name && this._childByName[child._name] == child)
            {
                this._childByName[child._name] = undefined;
            }
        })

    }
    return this._childByName[name]
};

//重命名节点时处理
var setName = cc._BaseNode.prototype.setName;
cc.js.set(cc._BaseNode.prototype, "name", (function(name) {
    if(this._parent && this._parent._childByName)
    {
        var oldName = this._name;
        if(oldName && this._parent._childByName[oldName] === this)
        {
            this._parent._childByName[oldName] = undefined;
        }
        if(name)
        {
            this._parent._childByName[name] = this;
        }
    }
    setName.call(this,name);
}), false,true);


/*解决精灵在初始是隐藏的时候设置图片引起报错*/
let oldmarkForUpdateRenderData =  cc.Sprite.prototype.markForUpdateRenderData
cc.Sprite.prototype.markForUpdateRenderData= function(enable) {
    if(this.node)
    {
        oldmarkForUpdateRenderData.call(this,enable)
    }
  }

let oldmarkForRender =  cc.Sprite.prototype.markForRender
cc.Sprite.prototype.markForRender= function(enable) {
    if(this.node)
    {
        oldmarkForRender.call(this,enable)
    }
}

//重写RotateBy函数，不是通用函数，比起2D转动只能转动y轴
cc.RotateBy3D = cc.Class({
    name: 'cc.RotateBy3D',
    extends: cc.RotateBy,
    update:function (dt) {
        dt = this._computeEaseTime(dt);
        if (this.target) {
            let yAngle = this._startAngle + this._deltaAngle * dt
            if (this.target.eulerAngles.y != yAngle) {
                let newRotation = cc.quat()
                let newEulerAngles = this.target.eulerAngles;
                newEulerAngles.y = yAngle;
                newRotation.fromEuler(newEulerAngles);
                this.target.setRotation(newRotation.x, newRotation.y, newRotation.z, newRotation.w);
            }
        }
    },
});
cc.rotateBy3D = function (duration, deltaAngle) {
    return new cc.RotateBy3D(duration, deltaAngle);
};

//重写RotateBy函数，不是通用函数，比起2D转动只能转动y轴
cc.RotateByZ3D = cc.Class({
    name: 'cc.RotateByZ3D',
    extends: cc.RotateBy,
    update:function (dt) {
        dt = this._computeEaseTime(dt);
        if (this.target) {
            let yAngle = this._startAngle + this._deltaAngle * dt
            this.target.angle = yAngle
        }
    },
});
cc.rotateByZ3D = function (duration, deltaAngle) {
    return new cc.RotateByZ3D(duration, deltaAngle);
};

//重写MoveBy函数，不是通用函数，比2D的Z3D的Z不移动
cc.MoveBy3D = cc.Class({
    name: 'cc.MoveBy3D',
    extends: cc.MoveBy,

    update:function (dt) {
        dt = this._computeEaseTime(dt);
        if (this.target) {
            var x = this._positionDelta.x * dt;
            var y = this._positionDelta.y * dt;
            var z = this.target.z
            var locStartPosition = this._startPosition;
            if (cc.macro.ENABLE_STACKABLE_ACTIONS) {
                var targetX = this.target.x;
                var targetY = this.target.y;
                var locPreviousPosition = this._previousPosition;

                locStartPosition.x = locStartPosition.x + targetX - locPreviousPosition.x;
                locStartPosition.y = locStartPosition.y + targetY - locPreviousPosition.y;
                x = x + locStartPosition.x;
                y = y + locStartPosition.y;
	            locPreviousPosition.x = x;
                locPreviousPosition.y = y;
                this.target.setPosition(x, y);
            } else {
                this.target.setPosition(locStartPosition.x + x, locStartPosition.y + y);
            }
            this.target.z = z
        }
    },
});
cc.moveBy3D = function (duration, deltaPos, deltaY) {
    return new cc.MoveBy3D(duration, deltaPos, deltaY);
};


/**
 * 自定义抖动动作
 */
var Shake = cc.ActionInterval.extend({
    //节点初始位置
    nodeInitialPos:null,
    //X轴抖动幅度
    nodeShakeStrengthX:0,
    //Y轴抖动幅度
    nodeShakeStrengthY:0,
    //抖动时间
    duration:0,
    ctor:function(duration,shakeStrengthX,shakeStrengthY){
        this.duration = duration;
        this.initWithDuration(duration,shakeStrengthX,shakeStrengthY);
    },
    //获取两个数间的随机值
    getRandomStrength:function(min,max){
        return Math.random()*(max-min+1)+min;
    },
    update:function(dt){
        var randX=this.getRandomStrength(-this.nodeShakeStrengthX,this.nodeShakeStrengthX)*dt;
        var randY=this.getRandomStrength(-this.nodeShakeStrengthY,this.nodeShakeStrengthY)*dt;
        var endPos = this.nodeInitialPos.add(cc.v2(randX,randY))
        this.target.setPosition(endPos)
    },
    initWithDuration:function(duration,shakeStrengthX,shakeStrengthY){
        if (cc.ActionInterval.prototype.initWithDuration.call(this, duration)) {
            this.nodeShakeStrengthX=shakeStrengthX;
            this.nodeShakeStrengthY=shakeStrengthY=='undefined'?shakeStrengthX:shakeStrengthY;
            return true;
        }
        return false;
    },
    startWithTarget:function(target){
        cc.ActionInterval.prototype.startWithTarget.call(this, target);
        this.nodeInitialPos=target.getPosition();
    },
    stop:function(){
        this.target.setPosition(this.nodeInitialPos);
    }
});
/**
 * 自定义抖动动作
 * @param {float}duration 抖动时间
 * @param {number}shakeStrengthX X轴抖动幅度
 * @param {number}shakeStrengthY Y轴抖动幅度
 * @returns {Shake}
 */
cc.shake = function(duration,shakeStrengthX,shakeStrengthY){
    return new Shake(duration,shakeStrengthX,shakeStrengthY);
}

//缓冲池如果父窗口保证不变的时候可以用(如果换的话会出错,NodePool模块可去除
if(cc.NodePool){
    cc.NodePool.prototype.putNotRemoveParent = function(obj) {
        if (obj && -1 === this._pool.indexOf(obj)) {
            // obj.removeFromParent(false);
            var handler = this.poolHandlerComp ? obj.getComponent(this.poolHandlerComp) : null;
            handler && handler.unuse && handler.unuse();
            this._pool.push(obj);
        }
    }
}


// 快速绑定点击函数 touchSilence-是否静默点击 Shield-是否有点击cdTime
cc.Node.prototype.longpressTouch = function(fn, touchScale, Shield,touchSilence) {
    this.unbindTouch();
    
    this.lastClickTime = 0; // 上次点击时间
    this.clickCdTime = 300  // 毫秒
    this.canTouch = true;
    this.iHasTouchBegan = false;
    this.getComponent(cc.BlockInputEvents) || this.addComponent(cc.BlockInputEvents)
    let timeSpSetp = new cc.Sprite();
    this.on(cc.Node.EventType.TOUCH_START, function(event) {
        GM.touchScreen = true
        if (this.canTouch == false){
            return;
        }
        this.iHasTouchBegan = true;
        this.BeganScale_ = this.scale;
        this.BeganOpacity_ = this.opacity;
        if (!touchScale) {
            this.setScale(this.BeganScale_*0.9);
            this.opacity = this.BeganOpacity_*0.9;
        };
        timeSpSetp.schedule(()=>{
            fn && fn(event);
        },0.2)
    }, this);

    this.on(cc.Node.EventType.TOUCH_CANCEL, function(event) {
        if (this.canTouch == false) {
            return;
        }
        if (this.iHasTouchBegan == false) {
            return;
        }

        // GM.hasTouchDown = false;
        this.iHasTouchBegan = false;

        if (!touchScale) {
            this.setScale(this.BeganScale_);
            this.opacity = this.BeganOpacity_;
        };
        timeSpSetp.unscheduleAllCallbacks()
    }, this);

    this.on(cc.Node.EventType.TOUCH_END, function(event) {
        if (this.canTouch == false) {
            return;
        }
        if (this.iHasTouchBegan == false) {
            return;
        }

        // GM.hasTouchDown = false;
        this.iHasTouchBegan = false;

        if(audioData && !touchSilence){
            audioData.playSoundByID(2)
        }

        if (!touchScale) {
            this.setScale(this.BeganScale_);
            this.opacity = this.BeganOpacity_;
        };
        timeSpSetp.unscheduleAllCallbacks()
        // if (!Shield) {
        //     var now = (new Date()).getTime();
        //     if (now - this.lastClickTime < this.clickCdTime) {
        //         console.log("---屏蔽过快点击---",now,this.lastClickTime,this.clickCdTime);
        //         return;
        //     };
        //     this.lastClickTime = now;
        // };
        fn && fn(event);
        // console.log("TOUCH_END");
    }, this);

    this.autoClick = function () {
        fn();
    }

    return this;
};


cc.loadResNow = function(url) {
    return new Promise( function(resolve,reject){
    cc.resources.load(url,function(err,content){
    resolve({e:err,v:content});
    });
    } );
}

cc.WebView.Impl.prototype.evaluateJS = function (str) {
    var iframe = this._iframe;
    console.log('[extend evaluateJS]')
    if (iframe) {
        return iframe.evaluateJS(str);
    }
};
// let _onHierarchyChanged =  cc.Node.prototype._onHierarchyChanged
// cc.Node.prototype._onHierarchyChanged  = function(oldParent) {
//     _onHierarchyChanged.call(this,oldParent)
//     this.emit("active",this.activeInHierarchy)
// }